<template>
  <div class="col-md-4 gapping">
    <div class="commanContent gapping-bottom">
      <div class="row rowContract">
        <div class="col-10">
          <ul class="listContract">
            <li>{{job.Job_ID}}</li>
            <li>
              {{job.job_type}}
              <span class="transparent">{{getJobStatus}}</span>
            </li>
          </ul>
        </div>

        <div class="col-2">
          <div class="row position">
            <a v-on:click="share(job.id)">
              <img
                :src="geturl+'new-design/share.png'"
                class="icon-cus-img icon-share-gap margin-right"
              />
            </a>

            <div v-if="isAuthenticated ">
              <a title="Save" v-on:click="handleSaveJob">
                <img
                  v-if="isJobSaved"
                  class="icon-cus-img icon-wish-gap margin-right"
                  :src="geturl + 'new-design/wishlist-1.png'"
                />
                <img
                  v-else
                  class="icon-cus-img icon-wish-gap margin-right"
                  :src="geturl +'new-design/notwhistlist.png'"
                />
              </a>
            </div>

            <div v-else>
              <a @click.prevent="openLoginPopup">
                <img
                  class="icon-cus-img icon-wish-gap margin-right"
                  :src="geturl + 'new-design/wishlist-2.png'"
                />
              </a>
            </div>
          </div>
        </div>
      </div>
      <div class="row rowContract">
        <a @click="redirectToDetail(job.id)">
          <h5 class="title-1">{{job.posting_title}}</h5>
        </a>
        <div v-if="user.role_id == 2" class="col-md-12">
          <div class="cus-verticale-center">
            <div class="text-red inlineText">
              <img :src="geturl +'new-design/dollar.png'" class="icon-cus-img" />
              <span class="ml-1 gap">MYR</span>
              <span
                class="c-job-base-rate"
                v-bind:id="'con-copy-1' + job.id"
              >{{ job.job_base_rate }}/day</span>
              <div
                @click.prevent="calculateRate(job.job_base_rate)"
                class="iconBox iconCopy inlineText copy-to-clipboard job-tile-button-right d-inline icon-cus-img"
              ></div>
            </div>
          </div>
        </div>
        <div v-else class="col-md-12">
          <a @click.prevent="openLoginPopup" class="text-blue iconLogin login-form-poup">
            <img :src="geturl +'new-design/dollar.png'" class="icon-cus-img" />
            <span>Login as Consultant to view Pay Rate</span>
          </a>
        </div>
      </div>
      <div class="row rowContract">
        <div class="col-6 col-sm-6 col-md-6 col-lg-6 col-xl-6">
          <img :src="geturl +'cus-ull-time.png'" class="icon-cus-img" />
          <div class="ml-1 Black d-inline gap">{{job.job_mode}}</div>
        </div>

        <div class="col-6 col-sm-6 col-md-6 col-lg-6 col-xl-6">
          <img :src="geturl +'cus-month.png'" class="icon-cus-img" />
          <div class="ml-1 Black d-inline gap">{{job.job_duration}} months</div>
        </div>
      </div>

      <div class="row rowContract">
        <div class="col-6 col-sm-6 col-md-6 col-lg-6 col-xl-6">
          <img :src="geturl +'cus-experience.png'" class="icon-cus-img" />
          <div class="ml-1 Black d-inline gap">{{job.work_experience}}</div>
        </div>

        <div class="col-6 col-sm-6 col-md-6 col-lg-6 col-xl-6">
          <img :src="geturl +'cus-oil.png'" class="icon-cus-img" />
          <div class="ml-1 Black d-inline gap">{{job.industry.substring(0,10)+".."}}</div>
        </div>
      </div>

      <div class="row rowContract">
        <div class="col-6 col-sm-6 col-md-6 col-lg-6 col-xl-6">
          <img :src="geturl +'cus-start.png'" class="icon-cus-img" />
          <div class="ml-1 Black d-inline gap">{{job.date_opened}}</div>
        </div>

        <div class="col-6 col-sm-6 col-md-6 col-lg-6 col-xl-6">
          <img :src="geturl +'cus-location.png'" class="icon-cus-img" />
          <div class="ml-1 Black d-inline gap">{{job.city.substring(0,9)+".."}}</div>
        </div>
      </div>
      <div v-if="user.role_id == 2" class="boxbtns job-tile-button-right border-top-btn">
        <div v-if="!getJobStatus" class="row no-gutters">
          <div class="col-md-12 text-center btn-apply-full">
            <img
              v-if="isLoadingApplyJob"
              :src="geturl +'loader.svg'"
              class="consultant-img-loader"
            />
            <a
              v-else
              title="Apply Now!"
              @click.prevent="handleApplyJob"
              class="btn btn-danger btn-block consultant-job-applied btn-custom-trans colorRed btn-apply-icon"
            >Apply Now!</a>
          </div>
        </div>
        <div class="row">
          <div v-if="getJobStatus === 'Associated'" class="col-md-12  text-center">
            <img
              v-if="isLoadingWithdrawJob"
              :src="geturl +'loader.svg'"
              class="consultant-img-loader"
            />
            <a
              v-else
              title="Withdraw Application"
              @click.prevent="handleWithdraw"
              class="btn btn-block btn-danger btn-md btn-custom-trans colorRed btn-apply-icon"
            >Withdraw Application</a>
          </div>
          <div
            v-if="getJobStatus === 'Application Withdrawn'"
            class="col-md-12  text-center"
          >
            <a
              title="Application Withdrawn"
              href="javascript:void(0)"
              class="btn btn-block btn-danger btn-md btn-custom-trans colorRed btn-apply-icon"
              style="opacity: 0.5; cursor: not-allowed;"
            >Application Withdrawn</a>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import api from "../../api/jobs";

export default {
  props: {
    job: {
      type: Object
    },
    user: {
      type: Object
    }
  },
  data() {
    return {
      countryCode: null,
      isLoadingSaveJob: false,
      isLoadingApplyJob: false,
      isLoadingWithdrawJob: false,
      isJobFresh: false
    };
  },
  computed: {
    geturl : function() { 
    let curr = process.env.MIX_API_URL;
    this.fullurl = curr +  "/public/images/";
    return this.fullurl;
    },
    normalizeAssociated() {
      return this.job.associatecandidates.filter(job => {
        return job.CANDIDATEID == this.user.zoho_id;
      });
    },
    isAuthenticated() {
      if (this.user.role_id === 0) return false;
      return true;
    },
    isJobSaved() {
      if (this.normalizeAssociated.length < 1) return false;
      if (this.normalizeAssociated.pop().job_save === 1) {
        return true;
      } else {
        return false;
      }
    },
    getJobStatus() {
      var length = this.normalizeAssociated.length;
      if (length === 0) {
        return null;
      }
      return this.normalizeAssociated[0].status;
    }
  },
  methods: {
    share(id) {
      let url =
        process.env.MIX_API_URL+"/"+this.countryCode+"/job-details/" + id;
      this.$clipboard(url);
      this.$notify({
        group: "foo",
        title: "Message",
        text: "Profile URL has been copied!"
      });
    },
    redirectToDetail(id) {
      window.location.replace(process.env.MIX_API_URL+"/"+this.countryCode+"/job-details/" + id);
    },
    calculateRate(rate) {
      this.$notify({
        group: "foo",
        title: "Notification",
        text: "Your Billing Rate has been Copied !"
      });
      this.$emit("calculate-rate", parseFloat(rate));
    },
    openLoginPopup() {
      $("html, body").animate({ scrollTop: 0 }, "slow");
      event.stopPropagation();
      $(".forgot-form-block").hide();
      $(".login-form-toggle").toggle(200);
      $(".login-form-block").show(200);
    },
    handleSaveJob() {
      if (this.user.role_id === 0) return;
      let data = {
        _token: document.head
          .querySelector('meta[name="csrf-token"]')
          .getAttribute("content"),
        zoho_id: this.job.JOBOPENINGID,
        job_id: this.job.id
      };
      this.isLoadingSaveJob = true;
      if (this.isJobSaved) {
        delete data.job_id;
        api
          .deleteJob(this.countryCode, data)
          .then(res => {
            this.isLoadingSaveJob = false;
            this.$emit("refresh-jobs");
          })
          .catch(err => {
            this.isLoadingSaveJob = false;
          });
      } else {
        api
          .saveJob(this.countryCode, data)
          .then(res => {
            this.isLoadingSaveJob = false;
            this.$emit("refresh-jobs");
          })
          .catch(err => {
            this.isLoadingSaveJob = false;
          });
      }
    },
    handleApplyJob() {
      if (this.user.role_id === 0) {
        this.openLoginPopup();
        return;
      }
      let data = {
        _token: document.head
          .querySelector('meta[name="csrf-token"]')
          .getAttribute("content"),
        zoho_id: this.job.JOBOPENINGID,
        job_id: this.job.id
      };
      this.isLoadingApplyJob = true;
      api
        .appliedJob(this.countryCode, data)
        .then(res => {
          this.isLoadingApplyJob = false;
          this.$emit("refresh-jobs");
        })
        .catch(err => {
          this.isLoadingApplyJob = false;
        });
    },
    handleWithdraw() {
      let data = {
        _token: document.head
          .querySelector('meta[name="csrf-token"]')
          .getAttribute("content"),
        zoho_id: this.job.JOBOPENINGID,
        job_id: this.job.id
      };
      this.isLoadingWithdrawJob = true;
      api
        .withdrawJob(this.countryCode, data)
        .then(res => {
          this.$emit("refresh-jobs");
          this.isLoadingWithdrawJob = false;
        })
        .catch(err => {
          this.isLoadingWithdrawJob = false;
        });
    }
  },
  mounted() {
    
    // Search Country Code
    let url = window.location.href;
    if (window.location.href.search("MY")) {
      this.countryCode = "MY";
    } else {
      this.countryCode = "PH";
    }
  }
};
</script>
<style>
.listContract {
  margin-left: -5px !important;
}
.icon-share-gap {
  margin-right: 10px;
}
.icon-wish-gap {
  margin-right: 16px;
}
.position {
  float: right;
}
.icon-cus-img {
  height: 16px !important;
  width: 16px !important;
}

.title-1 {
  overflow: hidden;
  height: 32px;
  line-height: 16px;
  display: -webkit-box;
  -webkit-line-clamp: 2;
  -webkit-box-orient: vertical;
  -o-text-overflow: ellipsis;
  text-overflow: ellipsis;
}
.gapping {
  padding-right: 5px !important;
  padding-left: 5px !important;
}
.gapping-bottom {
  margin-bottom: 10px !important;
}
.icon-cus-img {
  margin-right: 0px !important;
}

.margin-right {
  margin-right: 10px !important;
}
.transparent {
  display: none;
}
</style>